// create log file with results of OR (95% CI) pval
// produce sentences depending on data

use outputRRpval, clear
qui{

noi list

capture log close
log using outputRRpval.txt, replace
noi di " "
noi di " "
forvalues i = 1/7{

noi di "The " studyName[`i'] " reported", _continue
if RR[`i'] != .{
  noi di " an OR of " %4.2f RR[`i'], _continue
  if RRlow[`i'] != . & RRupp[`i'] != .{
    noi di " (95% CI " %4.2f RRlow[`i'] ", " %4.2f RRupp[`i'] ")", _cont
  }
}
if RR[`i'] != . & pval[`i'] != .{
  noi di " with", _cont	// JOIN IF RR AND pval PRESENT
}
if pval[`i'] != .{
  noi di " a p-val of " %4.2f pval[`i'], _cont
}
if RR[`i'] == . & pval[`i'] == .{
  noi di " no quantifiable result", _cont
}
noi di " "

}
noi di " "
noi di " "
log close
} // end qui
