
/**/
forvalues asl=101/112{
	foreach pat of global patologie{
		use  "${dirarc}06_percorso_breve_`pat'${anno}.dta",clear
		contract class_evento class_lett
		drop if class_evento==.
		drop _freq
		sort class_lett
		gen ord_lett=.
		replace ord_lett=1 if class_lett=="N"
		replace ord_lett=2 if class_lett=="R"
		replace ord_lett=3 if class_lett=="A"
		replace ord_lett=4 if class_lett=="Z"
		replace ord_lett=5 if class_lett=="Y"
		replace ord_lett=6 if class_lett=="X"
		replace ord_lett=7 if class_lett=="U"
		replace ord_lett=8 if class_lett=="O"
		sort class_lett
		save ${diracc}class_evento_`asl'.dta,replace
		use  "${dirarc}06_percorso_breve_`pat'${anno}.dta",clear
		keep if asl==`asl'
		qui gen time=fine_evento
		sort id_blind time
		
		/*si tiene l'ultima osservazione di ciascun soggetto*/
		keep if tag_finale==1
		drop evento class_evento class_lett
		/*si contano i deceduti al termine del ricovero indice*/
		qui count if deceduto_dimi_sdo==0
		local dimessivivi`asl'`pat'=`r(N)'
		qui count if deceduto_dimi_sdo==0 & deceduto_ale==1
		local decvivi`asl'`pat'=`r(N)'
		local percdecvivi`asl'`pat'=string((`decvivi`asl'`pat''/`dimessivivi`asl'`pat'')*100,"%03.1f")
		
		qui gen percorso_new=subinstr(percorso,"N","",.)
		qui replace percorso_new=subinstr(percorso_new,"S","",.)
		qui replace percorso_new=substr(percorso_new,1,3)
		qui replace percorso_new="IN" if percorso_new=="I" & deceduto_dimi_sdo==0
		qui gen int len=length(percorso_new)
		sum len
		local maxlen=`r(max)'
		forvalues k=1/`maxlen'{
			local kp=`k'-1
			qui gen  nodo`k'=substr(percorso_new,1,`k')
			qui gen  class_lett=substr(percorso_new,`k',1)
			
			sort class_lett
			merge class_lett using ${diracc}class_evento_`asl'.dta,uniqusing nokeep
			drop _merge
			rename class_evento cod_lett`k'
			rename class_lett lett`k'
			label values cod_lett`k' class_evento_label
			bysort nodo`k':gen quanti`k'=_N
			bysort nodo`k':egen deceduto`k'=sum(deceduto_ale)
			if `k'==2{
				qui bysort nodo`k':egen tempo_median`k'=median(distanza_dimi_riab_sogg)
				qui bysort nodo`k':egen tempo_min`k'=pctile(distanza_dimi_riab_sogg),p(25)
				qui bysort nodo`k':egen tempo_max`k'=pctile(distanza_dimi_riab_sogg),p(75)
				}
			}
		/********************************************************************/
		/*si scrive un archivio che riassume le informazioni di tutti i nodi*/
		/********************************************************************/
		gen quanti=_N
		contract percorso_new nodo1-nodo`maxlen' quanti1-quanti`maxlen'  tempo_median2  tempo_min2 tempo_max2 cod_lett1-cod_lett`maxlen' deceduto-deceduto`maxlen' quanti
		drop _freq
		
		local nodi ""
		forvalues k=1/`maxlen'{
			qui levels nodo`k' if lett`k'!="",clean
			local nodi =`" `nodi' "'+`" `r(levels)' "'
			}
		local numnodi:word count `nodi'
		tempname nod
		file open `nod' using ${dirasl}06_nodi.csv,write replace
		file write `nod' `"nodo,len,quanti,perc,deceduti,percdec,time_median,time_max,time_min,nodo_prec,"'
		file write `nod' `"lett"'_n
		tokenize `"`nodi'"'
		qui gen aux=_n
		forvalues i=1/`numnodi'{
			local nodo "``i''"
			file write `nod' `"`nodo',"' 
			local len=length(`"`nodo'"')
			file write `nod' `"`len',"' 
			qui sum quanti`len' if nodo`len'==`"`nodo'"'
			local quanti=`r(max)'
			file write `nod' `"`quanti',"'
			local perc=(`quanti'/`dimessivivi`asl'`pat'')*100
			file write `nod' `"`perc',"' 
			qui sum deceduto`len' if nodo`len'==`"`nodo'"'
			local dec=`r(max)'
			file write `nod' `"`dec',"' 
			local percdec=(`dec'/`quanti')*100
			file write `nod' `"`percdec',"' 
			local lett=substr(`"`nodo'"',-1,1)
			foreach step in median max min{
				local time_`step'=""
				if "`lett'"!="I"&"`lett'"!="N" &"`lett'"!="D"&`len'==2{
					qui sum tempo_`step'`len' if nodo`len'==`"`nodo'"'
					capture confirm number `r(max)'
					if _rc==0{
						local time_`step'="`r(max)'"
						}
					}
				file write `nod' `"`time_`step'',"' 
				}
			
			
			local nodo_prec=cond(`len'==1,"origine",substr(`"`nodo'"',1,`len'-1))
			file write `nod' `"`nodo_prec',"'
			file write `nod' `"`lett'"'_n
			}
		file close `nod'
		insheet using ${dirasl}06_nodi.csv, delimiter(",") clear
		
		rename lett class_lett
		sort class_lett
		merge class_lett using ${diracc}class_evento_`asl'.dta,uniqusing nokeep
		rename class_lett lett
		do ${diracc}class_evento_label_`pat'.do
		
		sort len
		label variable nodo "Nodo"
		label variable quanti "Numero soggetti" 
		label variable perc "Percentuale"
		label variable time_median "Tempo mediano di inizio percorso"
		label variable time_max "Tempo massimo di inizio percorso"
		label variable time_min "Tempo minimo di inizio percorso"
		save "${dirarc}07_tree_`asl'`pat'${anno}.dta",replace
		}
	
	
	foreach pat of global patologie{
		use "${dirarc}07_tree_`asl'`pat'${anno}.dta",clear
		qui sum len
		local maxlen=`r(max)'
		/*si etichettano gli eventi con le etichette corte*/
		do ${diracc}class_evento_label_short_`pat'.do
		label values class_evento class_evento_label_short
		/*si definisce l'ordine dei nodi*/
		gen ord_nodi=0
		forvalues j=1/`maxlen'{
			capture drop _merge
			gen str1   lett`j'=substr(nodo,`j',1)
			rename lett`j' class_lett
			sort class_lett
			merge class_lett using ${diracc}class_evento_`asl'.dta,keep(class_lett ord_lett) nokeep
			rename ord_lett ord`j'
			drop class_lett
			replace ord_nodi=ord_nodi*100+ord`j' if len>=`j'
			}
		sort ord_nodi
		replace ord_nodi=_n
		/*per costruire l'albero serve contare quanti rami ci sono dopo ogni nodo*/
		gen int quantirami=1
		gen aux1=`maxlen'-len+1
		sort aux1
		forvalues j=1/`maxlen'{
			qui bysort nodo_prec:egen quantirami`j'=sum(quantirami)
			*list nodo nodo_prec quantirami`j' quantirami
			levels nodo if aux1==`j'
			tokenize `"`r(levels)'"'
			local quantilevel: word count `r(levels)'
			forvalues s=1/`quantilevel'{
				local value "``s''"
				qui sum quantirami`j' if nodo_prec=="`value'"
				capture confirm number `r(max)'
				if _rc==0{
					qui replace quantirami=`r(max)'+2 if nodo=="`value'"
					}
				}
			drop quantirami`j'
			}
		drop aux1
		/************************/
		/*si costruisce l'albero*/
		/************************/
		/*si ordina in base alla lunghezza del nodo e all'ordine delle tappe*/
		sort ord_nodi
		/*si calcolano le coordinate*/
		local lung=29
		local alt=21
		local ascissa10=0
		local passo=`lung'/(`maxlen'+1)
		local pezzopasso=`passo'/3
		local ascissa20=`ascissa10'+`pezzopasso'
		forvalues k=1/`maxlen'{
			local kp=`k'-1
			local ascissa1`k'=`ascissa1`kp''+`passo'
			local ascissa2`k'=`ascissa1`k''+`pezzopasso'
			}
		bysort len:egen numnodi=sum(quantirami) 
		sort len
		local numlivelli=numnodi[1]
		local frazmin=`lung'/(`numlivelli')
		local ordinata0=`alt'/2
		local ordinataorigine=`ordinata0'
		count
		local quantinodi=r(N)
		*set trace on
		forvalues k=1/`quantinodi'{
			local nodo=nodo[`k']
			local nodo_prec=nodo_prec[`k']
			qui sum quantirami if nodo==nodo_prec[`k']
			capture confirm number `r(max)'
			if _rc!=0{
				local quantirami_tot=`numlivelli'+2
				}
			else{
				local quantirami_tot=`r(max)'+2
			
				}
			local partenza=`ordinata`nodo_prec''-(`quantirami_tot'/2)*`frazmin'
			qui egen parte=sum(quantirami) if ord_nodi<=ord_nodi[`k'] & nodo_prec==nodo_prec[`k']
			local quantisotto=parte[`k'] 
			drop parte
			local ordinata`nodo'=`partenza'+`quantisotto'*`frazmin'
			}
			
		/*si scrive il file tex*/
		capture mkdir ${dirasl}tabelle
		tempname alb
		file open `alb' using ${dirasl}albero_`asl'`pat'.tex,write replace
		file write `alb' `"%File generato automaticamente da Stata"'_n
		file write `alb' `"\documentclass{article}"'_n
		file write `alb' `"\usepackage[all]{xypic}"'_n
		file write `alb' `"%\usepackage{color}"'_n
		file write `alb' `"\usepackage{mathptmx}"'_n
		file write `alb' `"\newcommand{\dirtab}{${dirasl}tabelle}"'_n
		local altnew=`alt'+9
		local lungnew=`lung'-6
		file write `alb' `"\usepackage[margin=0.5cm,paperwidth=`lungnew'cm,paperheight=`altnew'cm,centering]{geometry}"'_n
		file write `alb' `"\begin{document}"'_n
		file write `alb' `"\thispagestyle{empty}"'_n
		file write `alb' `"\centering"'_n
		file write `alb' `"\begin{xy}"'_n
		*file write `alb' `"<`ascissa10'cm,`ordinata0'cm>="origine1","'_n
		*file write `alb' `"<`ascissa20'cm,`ordinata0'cm>="origine2","'_n
		qui count
		local quanti=r(N)
		*file write `alb' `""origine1"+/l1cm/,*\txt<2cm>{Ricovero per `pat'},"'_n
		forvalues k=1/`quantinodi'{
			local num_asc=len[`k']
			local nodo=nodo[`k']
			file write `alb' `"<`ascissa1`num_asc''cm,`ordinata`nodo''cm>="`nodo'1","'_n
			file write `alb' `"<`ascissa2`num_asc''cm,`ordinata`nodo''cm>="`nodo'2","'_n
			local class_evento=class_evento[`k']
			local lett=lett[`k']
			*local color=cond("`lett'"=="T","\color{blue}",cond("`lett'"=="D","\color{red}",""))
			local testo: label(class_evento) `class_evento'
			local perc=string(round(perc[`k'],.01),"%03.2f")
			local quanti=quanti[`k']
			local percdec=cond(percdec[`k']==0,"","("+string(round(percdec[`k'],.1),"%03.1f")+"\%)")
			local deceduti=deceduti[`k']
			*local bf=cond(`quanti'>100,"\bf","")
			if `num_asc'==1{
				file open tabella using ${dirasl}tabelle/tab`nodo'`asl'`pat'.tex,write replace
				file write tabella `"\begin{tabular}{l} "' _n
				file write tabella `"Ricoverati: `quanti' \\\ $\dagger$ `deceduti' `percdec'  \\\ Dimessi vivi: `dimessivivi`asl'`pat'' \\\ $\dagger$ `decvivi`asl'`pat'' (`percdecvivi`asl'`pat''\%) "' _n
				file write tabella `"\end{tabular}"' _n
				file close tabella
				file write `alb' `" "`nodo'1";"`nodo'2"**@{-}?(0.5)+/u0.2cm/*\txt<3cm>{\scriptsize `color'`testo'}?(0.5)+/d0.7cm/*\txt{`color'\scriptsize \input{\dirtab/tab`nodo'`asl'`pat'.tex}},"'_n
				}
			else if `num_asc'==2{
				file open tabella using ${dirasl}tabelle/tab`nodo'`asl'`pat'.tex,write replace
				file write tabella `"\begin{tabular}{l} "' _n
				file write tabella `"`quanti'   (`perc'\%) \\\ $\dagger$ `deceduti' `percdec' "' _n
				file write tabella `"\end{tabular}"' _n
				file close tabella
				file write `alb' `" "`nodo'1";"`nodo'2"**@{-}?(0.5)+/u0.2cm/*\txt<3cm>{\scriptsize `color'`testo'}?(0.5)+/d0.3cm/*\txt{`color'\scriptsize \input{\dirtab/tab`nodo'`asl'`pat'.tex}},"'_n
				}
			else{
				file write `alb' `" "`nodo'1";"`nodo'2"**@{-}?(0.5)+/u0.2cm/*\txt<3cm>{\scriptsize `color'`testo'}?(0.5)+/d0.1cm/*\txt{`color'\scriptsize `quanti' (`perc'\%)},"'_n
				}
			}
		levels nodo_prec
		tokenize `"`r(levels)'"'
		local quantiorig: word count `r(levels)'
		forvalues s=1/`quantiorig'{
			local orig "``s''"
			preserve
			keep if nodo_prec=="`orig'"
			qui count
			local quantifigli=r(N)
			forvalues j=1/`quantifigli'{
				local nodofiglio=nodo[`j']
				foreach step in median min max{
					local time_`step'=cond(time_`step'[`j']==.,"",string(time_`step'[`j']))
					
					}
				local timestring=cond("`time_median'"=="","","?(0.5)*\txt<2cm>{\scriptsize `time_median' giorni (`time_min'--`time_max')}")
				if "`nodofiglio'"!="I"{
					file write `alb' `" "`orig'2";"`nodofiglio'1"**@{-}`timestring',"'_n
					}
			
				}
			restore
			}
		
		file write `alb' `"\end{xy}"'_n
		file write `alb' `"\end{document}"'_n
		file close `alb'
		clear
		}
	
	
	
	/*si compilano gli alberi*/
	
				
	foreach pat of global patologie{
		shell pdflatex -job-name=${dirasl}albero_`asl'`pat' ${dirasl}albero_`asl'`pat'.tex
		*shell pdflatex -job-name=${dirasl}albero_`asl'`pat' ${dirasl}albero_`asl'`pat'.tex
		}
	}
			